//
//  MWVector.h
//  Malkinware
//
//  Created by Jim McGowan on 14/07/2011.
//  Copyright 2011 Jim McGowan. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef struct _MWVector {
	double angle;
	double magnitude;
} MWVector; // angle is in degrees


#define MWZeroVector MWMakeVector(0.0, 0.0)

MWVector MWMakeVector(double angle, double magnitude);
MWVector vectorForPoints(NSPoint startPoint, NSPoint endPoint);
NSPoint offsetForVector(MWVector vector);
NSPoint pointByApplyingVectorToPoint(NSPoint point, MWVector vector);
MWVector sumVectors(MWVector *vectorsArray, NSUInteger arrayCount);
MWVector averageVectors(MWVector *vectorsArray, NSUInteger arrayCount);

double degreesToRadians(double degreeValue);
double radiansToDegrees(double radianValue);

double wrapAngleInDegrees(double angle);

// Cocoa, Core Animation, etc, have 0/360 degrees at 3 o'clock and 90 degrees at 12 o'clock
// The vector functions here use a natural system, with 0/360 at 12 o'clock and 90 at 3 o'clock
double convertCocoaAngleToNaturalAngle(double cocoaAngle);
double convertNaturalAngleToCocoaAngle(double naturalAngle);


BOOL linesIntersect(NSPoint line1Start, NSPoint line1End, NSPoint line2Start, NSPoint line2End, NSPoint *outIntersectionPoint);