//
//  NSMutableAttributedStringExtensions.h
//  Malkinware
//
//  Created by Jim McGowan on 18/09/2008.
//  Copyright 2008 Jim McGowan. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "NSAttributedStringExtensions.h"
#import "NSTextAttachmentButtonCell.h"


@interface NSMutableAttributedString (MWNSMutableAttributedStringExtensions)

+ (NSMutableAttributedString *)mutAttStringWithString:(NSString *)str font:(NSFont *)font;

- (void)appendString:(NSString *)str font:(NSFont *)font;
- (void)appendString:(NSString *)str font:(NSFont *)font underline:(BOOL)underline;
- (void)appendString:(NSString *)str font:(NSFont *)font color:(NSColor *)color;
- (void)appendString:(NSString *)str font:(NSFont *)font color:(NSColor *)color indent:(CGFloat)indent;
- (void)appendString:(NSString *)str font:(NSFont *)font color:(NSColor *)color alignment:(NSTextAlignment)alignment;

- (void)appendImage:(NSImage *)image alignment:(NSTextAlignment)alignment;
- (void)appendButtonWithTitle:(NSString *)title target:(id)target action:(SEL)action representedObject:(id)object alignment:(NSTextAlignment)alignment;

@end
